	#define USE_DAQ
#define USE_MIKRO
// Izberi ustrezni interface v meniju projektnega okna
//  Options->CompilerDefines (dodaj /DSISVME ali /DWIENVME)
#ifdef USE_DAQ
#  define USE_CAMAC
#  ifdef SISVME
#    include "sisvme_dll.h"
#  endif
#  ifdef WIENVME
#    include "wienvme_dll.h"
#  endif
#  include "CAENV965.h"
#endif


#include "SpectraPro2155.h"
#include <utility.h>
#include <rs232.h>
#include <ansi_c.h>
#include <cvirte.h>		
#include <userint.h>

#include "CAENV462.h" 
#include "CAENV830.h"

#include "c:\MeasurementStudio\cvi\instr\MIKRO\MIKRO.h"

/*#define NGL 23
#define NSCA 11*/

static int panelHandle;
static int sp2155active=0;
static int plotHandle;
static int plotHandle2;
static int poolHandle;
static int tfID;

  #include <userint.h>
  #include <ansi_c.h>
  #include <utility.h>
  #include <vmescaler_ui.h>


  #define V673A1_ADDR 0x121000
  #define V673A2_ADDR 0x046000

  #define SCA1_ADDR 0x200000
  #define SCA2_ADDR 0x210000

  #define V462_ADDR 0x100300  

  #define MAX_THREADS 10


#define NTMAX 32
typedef struct { 
  int recid;
  int len;
  int time;
  int x,y;
  int xset,yset; 
  int ipos;
}  POSREC;

typedef struct {
 int recid;
 int len;
 int time;
 int id;
 int n;
} GRAPHREC;

static POSREC posrec;
static GRAPHREC graph[NTMAX];

double xval[1024],ydata[NTMAX][1024];
unsigned int   ixval[1024],iydata[NTMAX][1024];
int daqon=0;
int *pnt = &(posrec.recid);


#define MAX_CMD 124	
char gresult[MAX_CMD] ;
static int comport=7 ; 
    


int SP2155_Open(int port){
 int rs232er;  

 comport=port;
 rs232er = OpenComConfig (comport, "", 9600, 0, 8, 1, 512, 512);
 printf("SP2155_Open err=%d\n",rs232er);
 
 return  rs232er;  
}

int SP2155_Close(void){
 int rs232er;  
 rs232er = CloseCom(comport);
 return  rs232er;  
}



static int com_send ( char* cmd ) {
  char str1[1024] ;
  int err;  
  sprintf ( str1, "%s\r", cmd ) ;
 
  err= ComWrt (comport, str1, strlen(str1)); 
  //fprintf ( stdout, "Command: %s err=%d\t", cmd, err ) ;
  //printf("%d bytes written: %s ",err,str1);
  return err; 
 
}

static int com_read ( char* result ) {
  int err;
   int nbytes=1024;
   int maxsize=nbytes;
   result[0]=0;
   err = ComRdTerm (comport, result, nbytes,13);
   //CR=13
   if (err>0 && err>=maxsize) result[maxsize-1]=0;
   if (err>0 && err<maxsize) result[err]=0;
  // printf("err=%d bytes read=> #%s#\n\t",err,result);
   return err;
   
  
}


int SP2155_SendCmd ( char* cmd, char* result , float delay) 
{
  int i;
  int ncol=0;
  sp2155active=1;
#ifdef MAIN
	  SetCtrlVal(panelHandle,PANEL_LED,sp2155active);
#endif
  com_send ( cmd ) ;
  printf ( "cmd: %s\n", cmd ) ; 
  if (delay>0) Delay(delay);
  for (i=0;i<10;i++){     
  if ( com_read ( result ) ) {
    printf ( "answer: %s\n", result ) ;
    ncol++;
    if (strstr(result,"ok")!=NULL) break;
  }
  else { 
    printf ( "answer: Write Error\n") ;
    break;
  }
  }
  //printf ( "[%d lines read]\n",ncol ) ; 
  
  sp2155active=0;
#ifdef MAIN
	  SetCtrlVal(panelHandle,PANEL_LED,sp2155active);
#endif
  return ncol;
}  


#ifdef MAIN


int MTest (void){

   char result[1024];
   
   
   SP2155_SendCmd ("?NM", result,0 );
   SP2155_SendCmd ("NO-ECHO", result,0 );
   SP2155_SendCmd ("?GRATING", result,0 ); 
   SP2155_SendCmd ("?GRATINGS", result,0 );
   SP2155_SendCmd ("ECHO", result,0 ); 
   SP2155_SendCmd ("?TURRET", result,0 ); 
   
   SP2155_SendCmd ("?NM/MIN", result,0 ); 
   SP2155_SendCmd ("250.0 GOTO", result,0 ); 
   
   SP2155_SendCmd ("?NM", result,0 );  
   SP2155_SendCmd ("300.0 NM", result,0 ); 
   SP2155_SendCmd ("?NM", result,0 );
   SP2155_SendCmd ("NO-ECHO", result,0 ); 
 
    

return 0;
}

int CVICALLBACK SetWavelength (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
    char cmd[128];
    char result[1024]; 
    double wl;
	switch (event)
		{
		case EVENT_COMMIT:
		    if (sp2155active) return 0;
			GetCtrlVal(panel,PANEL_WL,&wl);
			sprintf(cmd,"%5.1f NM",wl);
            SP2155_SendCmd (cmd, result,0 ); 
            GetWavelength ( panel, control, event, callbackData, eventData1, eventData2); 
           
			break;
		}
	return 0;
}

int CVICALLBACK SetGrating (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	 char cmd[128];
    char result[1024];
    int wl;
	switch (event)
		{
		case EVENT_COMMIT:
		    if (sp2155active) return 0;
			GetCtrlVal(panel,PANEL_GRATING,&wl);
			sprintf(cmd,"%d GRATING",wl);
			SP2155_SendCmd (cmd, result,0 );
			GetGrating ( panel, control, event, callbackData, eventData1, eventData2);
             
            
			break;
		}
	return 0;
}

int CVICALLBACK SetVelocity (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
    char cmd[128];
    char result[1024];
    int wl;
	switch (event)
		{
		case EVENT_COMMIT:
		    if (sp2155active) return 0;
			GetCtrlVal(panel,PANEL_SPEED,&wl);
			sprintf(cmd,"%d NM/MIN",wl);
			SP2155_SendCmd (cmd, result,0 );  
			GetVelocity ( panel, control, event, callbackData, eventData1, eventData2);
            
			break;
		}
	return 0;
}

int CVICALLBACK GetWavelength (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{

    char result[1024];
	switch (event)
		{
		case EVENT_COMMIT:
		    if (sp2155active) return 0;
			SP2155_SendCmd ("?NM", result,0 ); 
            SetCtrlVal(panel,PANEL_CWL,result);
			break;
		}
	return 0;
}

int CVICALLBACK GetGrating (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{   
    char result[1024];
    
	switch (event)
		{
		case EVENT_COMMIT:
		    if (sp2155active) return 0;
			SP2155_SendCmd ("?GRATING", result,0 ); 
            SetCtrlVal(panel,PANEL_CGRATING,result);
			break;
		}
	return 0;
}

int CVICALLBACK GetVelocity (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
    
    char result[1024];
  
	switch (event)
		{
		case EVENT_COMMIT:
		    if (sp2155active) return 0;
		    SP2155_SendCmd ("?NM/MIN", result,0 ); 
            SetCtrlVal(panel,PANEL_CSPEED,result);
			break;
		}
	return 0;
}

                                     
 
    int vme_init(int delay ){
  int error;
  error = V462_map (0, V462_ADDR, 1);
  error = V462_set0 (0, delay);
  error = V462_set1 (0, 99);
   error = V462_start0 (0);
  
return 0;
}
		




int update_plots (int npoints, double *x, double *y)			
{
  int irange, ch;
  
  
  if (plotHandle>0) DeleteGraphPlot (panelHandle, PANEL_GRAPH, plotHandle, VAL_DELAYED_DRAW);
  plotHandle = PlotXY (panelHandle, PANEL_GRAPH, x, y,
					   npoints, VAL_DOUBLE, VAL_DOUBLE,
					   VAL_THIN_LINE, VAL_EMPTY_SQUARE,
					   VAL_SOLID, 1, VAL_RED);
  return (0);
}

int update_plots2 (int npoints, double *x, double *y)
{
  int irange, ch;
  
  
  if (plotHandle2>0) DeleteGraphPlot (panelHandle, PANEL_GRAPH2, plotHandle2, VAL_DELAYED_DRAW);
  plotHandle2 = PlotXY (panelHandle, PANEL_GRAPH2, x, y,
					   npoints, VAL_DOUBLE, VAL_DOUBLE,
					   VAL_THIN_LINE, VAL_EMPTY_SQUARE,
					   VAL_SOLID, 1, VAL_RED);
  return (0);
}



int GetScanPoints(char *fname, int *x, int *y){
  int i=0;   
  int ndim=400;
  char line[400];                                                                                                           
  int nb=0;
  int xx,yy;
  FILE *fp=fopen(fname, "r");
  if (fp!=NULL){

 float f[10];
  while (fgets(line,ndim,fp)!=NULL) {
    nb=sscanf(line,"%d%d",&xx,&yy);
    
    if (nb==2) {
      x[i]=xx;
      y[i]=yy;
      printf("%d %d %d\n",i,xx,yy);   
      i++;
    }
  }
  printf("Number of points %d\n", i);
  fclose(fp);
  return i;
}


return 0;
}

#define MAX 1024

int CVICALLBACK scan (void *functionData)
{
       int nb;    
      int vmin, vmax, n;
      unsigned long buffer[64];
		 float stime;
		 FILE *f;
	int i,j,k,cres,cresh,korak, error;
	char fpoints[256];
        int xpos[MAX], ypos[MAX], xset,yset,iscan,npoints;
	unsigned short ch;
	float delay;
	char fname[MAX],result[MAX],result1[MAX]; 
        GetCtrlVal (panelHandle, PANEL_FNAME, fname);
		GetCtrlVal(panelHandle, PANEL_OD,&vmin);
		GetCtrlVal(panelHandle, PANEL_DO,&vmax);
		GetCtrlVal(panelHandle, PANEL_KORAK,&n);

    daqon=1;       
	f=fopen(fname,"wb"); 

	if (f==NULL){ printf("Napaka pri odpiranju datoteke!\n");
	    daqon=0;
		return 1;
	}		 
	
	
	GetCtrlVal (panelHandle, PANEL_DELAY, &delay);
	printf("------------------------------------- %f = delay \n",delay);
       	V830_map (0, SCA1_ADDR,1);
       	V830_map (1, SCA2_ADDR,1);
        //	V462_map (0, V462_ADDR,1);
	//	V462_set0 (0, (int)(delay*1e7));
                	V830_init (0);
                    	V830_init (1);
                    
					
	korak =(vmax-vmin)/n;
	vme_init( (int)(delay*1e7));
	


	
    GetCtrlVal (panelHandle, PANEL_FPOINTS, fpoints);
	if (strlen(fpoints)>0){

          npoints= GetScanPoints(fpoints,xpos,ypos);
        } else {
          npoints=1;
          GetCtrlVal (panelHandle, PANEL_XPOS, &xpos[0]);
          GetCtrlVal (panelHandle, PANEL_YPOS, &ypos[0]);
        
       }
       for (iscan=0;iscan<npoints;iscan++){
      
          MIKRO_MoveTo(1,xpos[iscan]);       
          MIKRO_MoveTo(2,ypos[iscan]);
          MIKRO_GetPosition(1,&xset);
          MIKRO_GetPosition(2,&yset);
		  SetCtrlVal (panelHandle, PANEL_XSET, xset);
          SetCtrlVal (panelHandle, PANEL_YSET, yset); 

	      posrec.x=xpos[iscan];
	      posrec.y=ypos[iscan];
	      posrec.xset=xset;
	      posrec.yset=yset;
	      posrec.ipos=iscan;
	      posrec.time=time(NULL); 
	      posrec.recid=0x1; 
	      posrec.len= sizeof(POSREC);
	      fwrite (&posrec, sizeof(POSREC), 1, f);

	 
     	  for (i=0; i<n+1; i++){
		float val, retval;
		char cmd[MAX];
		val =  (vmin + i*1.0*(vmax-vmin)/n);
		
		SetCtrlVal(panelHandle, PANEL_LAMBDASET,val);       
	 
		sprintf(cmd,"%f GOTO",val);
		SP2155_SendCmd (cmd, result1,0 );
		Delay(0.25);
		SP2155_SendCmd ("?NM", result,0 );
		sscanf(result,"%f",&retval);
		SetCtrlVal(panelHandle, PANEL_VALOVNA,retval); 
		printf("%s %f\n",result, retval);
		Delay(0.25);
	                    
	        V462_start1 (0);//resetira uro 		
		 
	        V830_clear(0); //zbrise scaler
                         
		
		error = V462_start0 (0);   
		Delay(1.1);
		cres =0;
		
	                    
		V830_read(0,&buffer[0]);  /*prebere scaler*/ 
		             
		SetCtrlVal(panelHandle, PANEL_ZADETKI,cres);
	   
	       for (j=0;j<NTMAX;j++){
	    
	        if (buffer[j]) printf("%d %d\n",j,buffer[j]);
	        ydata[j][i]=buffer[j];  
	        iydata[j][i]=buffer[j];  
	       }
	   
	   
		
	
		xval[i]=val;
		ixval[i]=val;
        if (!daqon) break;
	    GetCtrlVal(panelHandle, PANEL_CH,&ch);  
		update_plots(i+1, xval,ydata[ch]);
		update_plots2(i+1, xval,ydata[ch]);

	   
        }
        
        for (j=0;j<NTMAX;j++){
          graph[j].recid = 0x2;
          graph[j].len   = sizeof(GRAPHREC)+2*(n+1)*sizeof(int);
          graph[j].id    = j;
          graph[j].n     = n+1;
          graph[j].time     = time(NULL);
          nb=fwrite (&graph[j], sizeof(GRAPHREC), 1, f);
          if (nb!= 1) printf("Write Error 1\n");         
          nb=fwrite (ixval    , sizeof(int), n+1, f);
          if (nb!= n+1) printf("Write Error 2\n");         
          nb=fwrite (iydata[j], sizeof(int), n+1, f);
          if (nb!= n+1) printf("Write Error 3\n");         
        }
        if (!daqon) break;

    }
    if (f) fclose(f);
    daqon=0;
    //SetCtrlVal(panelHandle, PANEL_VALOVNA,0.0);
    return 0;
}

  
  

int CVICALLBACK Test (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	switch (event)
		{
		case EVENT_COMMIT:
			MTest();
			break;
		}
	return 0;
}

int main (int argc, char *argv[])
{
    char result[1024];
    if (InitCVIRTE (0, argv, 0) == 0) return -1;	/* out of memory */

    SetSleepPolicy(VAL_SLEEP_MORE);
    CmtNewThreadPool (MAX_THREADS, &poolHandle);

    SetStdioWindowOptions (1000, 0, 0);
    SetStdioWindowSize (100, 600);
    SetStdioWindowPosition (650, 15);


    if ((panelHandle = LoadPanel (0, "SpectraPro2155.uir", PANEL)) < 0 ) return -1;
	MIKRO_Open(6);
    VME_START(NULL);
    SP2155_Open(7);
    SP2155_SendCmd ("NO-ECHO", result,0 ); 

    DisplayPanel (panelHandle);
    RunUserInterface ();
    DiscardPanel (panelHandle);
	
    SP2155_Close();
    VME_STOP();
    MIKRO_Close();  
    CmtDiscardThreadPool (poolHandle);
    return 0;
}

int CVICALLBACK Exit (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	switch (event)
		{
		case EVENT_COMMIT:
			QuitUserInterface(0);
			break;
		}
	return 0;
}

#endif

int CVICALLBACK zacni (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{

    int dummy;
	switch (event)
		{
		case EVENT_COMMIT:
                
                if (!daqon) CmtScheduleThreadPoolFunction (poolHandle, scan, (void *)&dummy, &tfID);
                
                //GetCtrlVal (p1h, P1_DAQ, &daq_on);
                //CmtWaitForThreadPoolFunctionCompletion (poolHandle, tfID, OPT_TP_PROCESS_EVENTS_WHILE_WAITING);
                //CmtReleaseThreadPoolFunctionID (poolHandle, tfID);

		}
	return 0;
}


int CVICALLBACK ckorak (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	int n1;
	int vmin1;
	int vmax1;
	float korak;
	switch (event)
		{
		case EVENT_COMMIT:
		
		GetCtrlVal(panel, PANEL_OD,&vmin1);
		GetCtrlVal(panel, PANEL_DO,&vmax1);
		GetCtrlVal(panel, PANEL_KORAK,&n1);
		korak = 1.0*(vmax1-vmin1)/n1;
		
		SetCtrlVal(panel, PANEL_RKORAK,korak);
		
			break;
		}
	return 0;
}

int CVICALLBACK UpdatePlotsCB (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
  	int n1;
    unsigned short ch;
	switch (event)
		{
		case EVENT_COMMIT:
			if (!daqon){
			
  	 	       GetCtrlVal(panel, PANEL_KORAK,&n1);
		       GetCtrlVal(panel, PANEL_CH,&ch);
		       update_plots(n1, xval,ydata[ch]);
		       update_plots2(n1, xval,ydata[ch]);
			}
			break;
		}
	return 0;
}

int CVICALLBACK SetXY (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
    int xpos,ypos,xset,yset;
	switch (event)
		{
		case EVENT_COMMIT:
		  GetCtrlVal (panelHandle, PANEL_XPOS, &xpos);
          GetCtrlVal (panelHandle, PANEL_YPOS, &ypos);
          MIKRO_MoveTo(1,xpos);       
          MIKRO_MoveTo(2,ypos);
          MIKRO_GetPosition(1,&xset);
          SetCtrlVal (panelHandle, PANEL_XSET, xset);
          printf("xset:%d\n",xset); 
          MIKRO_GetPosition(2,&yset);
          SetCtrlVal (panelHandle, PANEL_YSET, yset);           
          printf("yset:%d\n",yset); 
			break;
		}
	return 0;
}

int CVICALLBACK LoadFpoints (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
   char fpoints[MAX_PATHNAME_LEN];
   int nsel=0;
	switch (event)
	
		{
		case EVENT_COMMIT:
			nsel = FileSelectPopup ("", "*.*", "", "", VAL_LOAD_BUTTON, 0, 0, 1,
							0, fpoints);
			SetCtrlVal (panelHandle, PANEL_FPOINTS, fpoints);          
			break;
		}
	return 0;
}

int CVICALLBACK StopCB (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	switch (event)
		{
		case EVENT_COMMIT:
			if (daqon) daqon=0;
			break;
		}
	return 0;
}
