#include <userint.h>
#include <ansi_c.h>           
#define  WIENVME
#define USE_DAQ
// Izberi ustrezni interface v meniju projektnega okna
//  Options->CompilerDefines (dodaj /DSISVME ali /DWIENVME)


#ifdef USE_DAQ
#  define USE_CAMAC
#  ifdef SISVME
#    include "sisvme_dll.h"
#  endif
#  ifdef WIENVME
#    include "wienvme_dll.h"
#  endif
#endif


#include "caen_n470.h"  
#include "vmecaenet.h"    
#include <utility.h>   
int hHandle24;
int ModuleNumber=0;
int N470_moduleID=-1;

#define V288_BUF    0x0
#define V288_STATUS 0x2
#define V288_TX     0x4
#define V288_RST    0x8

#define V288_ADDR             0x100500
#define V288_ADDRESS_MODIFIER  0x39


FILE *fp;

static unsigned long ModuleAddress[10]; 

int V288_map (int ModuleNumber, unsigned long ModuleOffset, int print)
{
  ModuleAddress[ModuleNumber] = ModuleOffset;
  if (print) {
  }
  return 0;
}


int  V288_SingleRead(int ModuleNumber,unsigned int addr,  unsigned long *data,int print){

  long dum;
  int ret;
 // Delay(0.1); 
  ret = VME_A24D16_R ( ModuleAddress[ModuleNumber] +addr,(long *) data);
  //  usleep(50);
  ret = VME_A24D16_R (ModuleAddress[ModuleNumber] +V288_STATUS, &dum);
  if (print) printf("SingleRead Addr=0x%x Data=0x%x Status=0x%x\n",addr,(unsigned int )(*data),(unsigned int)dum);
  return dum;
};

int  V288_SingleWrite(int ModuleNumber, unsigned int  addr,  unsigned long data, int print){
  int ret;
  long dum;
 // Delay(0.1); 
  ret = VME_A24D16_W ( ModuleAddress[ModuleNumber] + addr, &data);
  //usleep(50);
  ret = VME_A24D16_R ( ModuleAddress[ModuleNumber] + V288_STATUS, &dum);
  if (print) printf("SingleWrite Addr=0x%x Data=0x%x Status=0x%x\n",addr,(unsigned int ) data,(unsigned int) dum);
  return dum;
};


int V288_Reset(int ModuleNumber){    
    V288_SingleWrite( ModuleNumber,V288_RST,0,1);
    Delay(1);
    return 0;
  };

int V288_init (int ModuleNumber){
  V288_Reset(ModuleNumber) ;
return 0;
}    
	

#define TIMEOUT 100
int V288_WaitForReady(int ModuleNumber){
   int ret;
  unsigned long dum;
  int ncount=0;
  Delay(1);
  do {
    ret=V288_SingleRead(ModuleNumber,V288_BUF, &dum,1 );
    ncount++;
  } while ((ret & 0x1)&ncount<TIMEOUT);
  if (ncount==TIMEOUT) printf("Wait TIMEOUT\n"); 

  return dum;
};


int V288_Read(int ModuleNumber,int max,int *data,int print){
  int ret;
  unsigned long dum;
  time_t timet;
  unsigned short *sdum=(unsigned short *)&dum;
  int ncount=0;
  if (print) fprintf(fp,"%lu\t",time(&timet));  
  do {
    ret=V288_SingleRead(ModuleNumber,V288_BUF, &dum,0 );
    if (ret & 0x1) continue;
    if (print) printf("Read %2d 0x%x 0x%x %d %c  \n",ncount+2,ret,*sdum,*sdum,*sdum);
    if (print) fprintf(fp,"%d\t",*sdum);
    if (ncount<max) data[ncount]=(unsigned short) dum;
    ncount++;
  } while (!(ret & 0x1) );
  if (print) fprintf(fp,"\n");
  return ncount;
}

int V288_WriteRead(int ModuleNumber,int id,int cmd,int n,int *indata, int ndata,int *data,int print){
    int i;
    V288_SingleWrite(ModuleNumber,V288_BUF, 1  , print);
    V288_SingleWrite(ModuleNumber,V288_BUF, id , print);
    V288_SingleWrite(ModuleNumber,V288_BUF, cmd, print);
   // printf("CAENET 1 %d %d ", id,cmd);
    for ( i=0;i<n;i++) {
      V288_SingleWrite( ModuleNumber,V288_BUF, indata[i]  , print );
       //printf("%d ",indata[i]);
    }
   // printf("\n");
    V288_SingleWrite(ModuleNumber,V288_TX, 0 ,print );
    V288_WaitForReady(ModuleNumber);
    return V288_Read(ModuleNumber,ndata,data,print);
  };  

int V288_Write(int ModuleNumber,int id,int cmd,int n,int *indata,int print){  
    int i;
    V288_SingleWrite(ModuleNumber,V288_BUF, 1  , print);
    V288_SingleWrite(ModuleNumber,V288_BUF, id , print);
    V288_SingleWrite(ModuleNumber,V288_BUF, cmd, print);
  	for ( i=0;i<n;i++) {
      V288_SingleWrite( ModuleNumber,V288_BUF, indata[i]  , print );
    }
    V288_SingleWrite(ModuleNumber,V288_TX, 0 ,print );                    
    return 0;
}    
 
int V288_HvSetStatusAlarm(int ModuleNumber, int id, int value){
    int dum;
  
     V288_WriteRead( ModuleNumber,id, 0x1A,1, 0, 1,&dum,0);
    return 0;
};

  
#define MAKE_CODE(ch,cod)     (((ch)<<8) | (cod))  

int  CAENET  (int ModuleNumber ,int function , int ch, int value, int * buff, int *nbuff){


 return  V288_WriteRead(ModuleNumber, N470_moduleID, MAKE_CODE(ch, function),1, &value,*nbuff,buff,1);
    
}  
  
int gptr2[4][11]={   {CAEN470_STATUS_0,  CAEN470_VMON_0, CAEN470_IMON_0, CAEN470_V0_0, CAEN470_I0_0, CAEN470_V1_0,
                    CAEN470_I1_0, CAEN470_TRIP_0, CAEN470_RUP_0, CAEN470_RDW_0,
                    CAEN470_MAXV_0},
					{CAEN470_STATUS_1,  CAEN470_VMON_1, CAEN470_IMON_1, CAEN470_V0_1, CAEN470_I0_1, CAEN470_V1_1,
                    CAEN470_I1_1, CAEN470_TRIP_1, CAEN470_RUP_1, CAEN470_RDW_1,
                    CAEN470_MAXV_1},
                    {CAEN470_STATUS_2,  CAEN470_VMON_2, CAEN470_IMON_2, CAEN470_V0_2, CAEN470_I0_2, CAEN470_V1_2,
                    CAEN470_I1_2, CAEN470_TRIP_2, CAEN470_RUP_2, CAEN470_RDW_2,
                    CAEN470_MAXV_2},
                    {CAEN470_STATUS_3,  CAEN470_VMON_3, CAEN470_IMON_3, CAEN470_V0_3, CAEN470_I0_3, CAEN470_V1_3,
                    CAEN470_I1_3, CAEN470_TRIP_3, CAEN470_RUP_3, CAEN470_RDW_3,
                    CAEN470_MAXV_3} };


int gptr1[4][4]={{ CAEN470_VMON_0, CAEN470_IMON_0, CAEN470_MAXV_0, CAEN470_STATUS_0},
				{ CAEN470_VMON_1, CAEN470_IMON_1, CAEN470_MAXV_1, CAEN470_STATUS_1},
				{ CAEN470_VMON_2, CAEN470_IMON_2, CAEN470_MAXV_2, CAEN470_STATUS_2},
				{ CAEN470_VMON_3, CAEN470_IMON_3, CAEN470_MAXV_3, CAEN470_STATUS_3}};

int gptr3[4]={CAEN470_CH_0,CAEN470_CH_1,CAEN470_CH_2,CAEN470_CH_3 }; 


CAEN470_parameters_operational HvOp[4];
CAEN470_parameters_monitor     Hv[4];

int init(){
 if (N470_moduleID < 0 )  V288_map(0,V288_ADDR,0);
 N470_moduleID=1;
 return 0;
};


int CAEN470_hvon(int ch){
 int null=0;
 init();
 CAENET(ModuleNumber,10, ch, 0 , &null, &null);
 return  0;
}

int CAEN470_hvoff(int ch){
 int null=0;
 init();
 CAENET(ModuleNumber,11, ch, 0 , &null, &null);
 return  0;
}


int CAEN470_hv(int ch){
 int nb=16;
 init();
 CAENET(ModuleNumber,1,0,0, &Hv[0].Vmon, &nb);
 return  Hv[ch].Vmon;
}


int CVICALLBACK CAEN470_Read (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
  int i,j,nb;
  int *iptr;
  
	switch (event)
		{
		case EVENT_COMMIT:
		    init();
		    for (i=0;i<4;i++ ) {
		        nb=11;
		    	CAENET(ModuleNumber,2,i,0, &HvOp[i].Status, &nb);
		    	
		    	iptr= &HvOp[i].Status;
		    	for (j=0;j<11;j++ ) {
		    	  SetCtrlVal(panel, gptr2[i][j],iptr[j]);
		    	  //printf("%d-- %d->%d\n",j, gptr2[i][j],*(iptr+j));
			    }
			    printf("%d.ch V=%d  %d %d\n", i,HvOp[i].Vmon, HvOp[i].V0, HvOp[i].V1 );
			    printf("%d.ch I=%d  %d %d\n", i,HvOp[i].Imon, HvOp[i].I0, HvOp[i].I1 );
			    printf("%d.ch R=%d  %d T=%d\n", i,HvOp[i].RampUp, HvOp[i].RampDown, HvOp[i].Trip );
			    printf("%d.ch MaxV=%d  \n", i,HvOp[i].MaxV );
	        }
	        
	        nb=16;
	        CAENET(ModuleNumber,1,0,0, &Hv[0].Vmon, &nb);
	        for (i=0;i<4;i++ ) {
			   iptr= &Hv[i].Vmon;
		       for (j=0;j<4;j++ ) {
		       	 SetCtrlVal(panel, gptr1[i][j],iptr[j]);
		         //printf("%d-- %d->%d\n",j,gptr2[i][j],iptr[j]);     
		       }
		       SetCtrlVal(panel, gptr3[i], Hv[i].Status & 0x1);
			}
			
			break;
		}
	return 0;
}

int CVICALLBACK CAEN470_Close (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	switch (event)
		{
		case EVENT_COMMIT:
			 //HidePanel(panel); 
			 QuitUserInterface(0);
			break;
		}
	return 0;
}


int CVICALLBACK CAEN_N470_Set (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
    int val, null=1,i,ch;
	switch (event)
		{
		case EVENT_COMMIT:
			printf("panel, control %d %d\n",panel,control);
			for (ch=0;ch<4;ch++) {
			   	for (i=1;i<8;i++) {  
				  if (control==gptr2[ch][i] ) {
				   GetCtrlVal(panel,control,&val);      
				   printf("gptr2  i %d code %d val %d  ch %d\n",i,i+2,val, ch); 
				   CAENET(ModuleNumber,i, ch, val, &null, &null); 
				   CAEN470_Read (panel, control, event, callbackData,eventData1,eventData2);
				   i=10;
				   ch=4;
				  }
				  
				}
				if (control==gptr3[ch] ) {
				   printf("gptr3 ch %d \n",ch); 
				   GetCtrlVal(panel,control,&val);
				   CAENET(ModuleNumber,11-val, ch, 0 , &null, &null);
				   CAEN470_Read (panel, control, event, callbackData,eventData1,eventData2);
				   ch=4;
				}   
			}
			break;
		}
	return 0;
}

#define MAIN
#ifdef MAIN


int p1h;
#define V288_ADDR 0x100500      

int main (int argc, char *argv[])
{
    int cmdline=0;
    int data[100] ;
    
    int nval=0;
    int addr=1;
    int cmd =1;
    int print=0;
    int val  =0;
	fp=stdout;
    if (argc>2){
       fp=fopen(argv[2],"a");
    }
    if (fp==NULL) {
       printf("Error opening file!\n");
	   return 0;
    }
    if (argc>1){
       if (atoi(argv[1])==1) cmdline=1;
    }
    if (argc>3){
       addr=atoi(argv[3]);
    }
    if (argc>4){
       cmd=atoi(argv[4]);
    }
    if (argc>5){
       nval=atoi(argv[5]);
    }
    if (argc>6){
       val=atoi(argv[6]);
    }
   
    
  
	if (InitCVIRTE (0, argv, 0) == 0)
		return -1;	/* out of memory */

    // initialize VME interface	
    VME_START(NULL);  
    N470_moduleID=-1;
    init();   
     
    
     if (!cmdline){
	    if ((p1h = LoadPanel (0, "caen_n470.uir", CAEN470)) < 0) return -1;
	    DisplayPanel (p1h);
	    RunUserInterface ();
	    DiscardPanel (p1h);     
	 } else {
	    
	   SetStdioPort (HOST_SYSTEM_STDIO);    
	    
	   V288_SingleWrite(ModuleNumber,V288_BUF, 1  , print);
       V288_SingleWrite(ModuleNumber,V288_BUF, addr , print);
       V288_SingleWrite(ModuleNumber,V288_BUF, cmd, print);
  
       if (nval) V288_SingleWrite(ModuleNumber,V288_BUF, val , print );
  
   // 
       V288_SingleWrite(ModuleNumber,V288_TX, 0 ,print );
	   Delay(0.1);
	  // printf("t=%lu\t", time(NULL));
	   V288_Read(ModuleNumber,nval,data, 0);
	   V288_Read(ModuleNumber,100,data, 1);
	 
	}
	 
	 // close VME interface
    VME_STOP(); 
	
	if (fp!=stdout) fclose(fp);
	return 0;
}
#endif

int CVICALLBACK WriteCB (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{     
    int   addr,val,cmd,nval ;

    int print=1;
	switch (event)
		{
		case EVENT_COMMIT:
		    GetCtrlVal(panel,CAEN470_ADDR,&addr);      
		    GetCtrlVal(panel,CAEN470_VAL,&val);   
		    GetCtrlVal(panel,CAEN470_CMD,&cmd);   
		    GetCtrlVal(panel,CAEN470_NVAL,&nval); 
		    
		    V288_SingleWrite(ModuleNumber,V288_BUF, 1  , print);
            V288_SingleWrite(ModuleNumber,V288_BUF, addr , print);
            V288_SingleWrite(ModuleNumber,V288_BUF, cmd, print);
  
           if (nval) V288_SingleWrite(ModuleNumber,V288_BUF, val , print );
  
   // printf("\n");
           V288_SingleWrite(ModuleNumber,V288_TX, 0 ,print );
	          
			break;
		}
	return 0;
}

int CVICALLBACK ReadCB (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
    int data[100] ;
    int nval ;
    int print=1;
	switch (event)
		{
		case EVENT_COMMIT:  
		    GetCtrlVal(panel,CAEN470_NVAL1,&nval);       
			V288_Read(ModuleNumber,nval,data,0);
		    V288_Read(ModuleNumber,100,data,print);
			break;
		}
	return 0;
}

int CVICALLBACK ScanCB (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
    int print=0;
    int i,k;
    int val;
    int   data[100] ; 
    int ch=0;
	switch (event)
		{
		case EVENT_COMMIT:
		for (i=1;i<20;i++){
		     val=i*10;
		     V288_Write(ModuleNumber, N470_moduleID, MAKE_CODE(ch,3),1,&val,print);
		     Delay(0.1);
		     V288_Read(ModuleNumber,100,data,print);
		     V288_Read(ModuleNumber,100,data,print);
		     
		     
		     Delay(5);
		     
			 V288_Write(ModuleNumber, N470_moduleID, 1,0,&val,print);
			  Delay(0.1);   
			 V288_Read(ModuleNumber,100,data, print);
			 V288_Read(ModuleNumber,100,data, print);
			 for (k=0;k<4;k++){ printf("%d\t", data[k*4+1]); };
			 printf("----------------------\n") ;
		}
			break;
		}
	return 0;
}
