#include <ansi_c.h>
#include <utility.h>
#include "visa.h"

#define MAX_CNT 200

FILE* fp;

int WriteRead(ViSession instr, char *cmd, int maxn, char *data){
int retCount, status;
 
status = viWrite(instr, cmd, strlen(cmd), &retCount);
status = viRead (instr, data, maxn, &retCount);

cmd[strlen(cmd)]=0;

if (retCount>0) data[retCount]=0;
fprintf(fp,"%u %s %s",time(NULL),cmd,data);

return retCount;
}


int main(int argc, char **argv){

char cmd[MAX_CNT];
//char *defaultcmd="*IDN?\n";
char *defaultcmd=":meas:curr?\n";
char icmd[10][50]={":CURR:AVER:COUNT 50\n",":CURR:RANGE:AUTO 0\n",
                   ":CURR:RANGE:UPPER 1e-5\n",":CURR:AVER:STATE 1\n",
                   ":INIT:CONT OFF\n", 
                   ":CURR:AVER:COUNT?\n",":CURR:RANGE:AUTO?\n",
                   ":CURR:RANGE:UPPER?\n",":CURR:AVER:STATE?\n",
                   ":INIT:CONT?\n",  };
char fname[120];
ViStatus status; /* For checking errors */
ViSession defaultRM, instr; /* Communication channels */
ViUInt32 retCount; /* Return count from string I/O */
ViChar buffer[MAX_CNT]; /* Buffer for string I/O */
time_t timet;
int i;


fp=stdout;
SetStdioPort (HOST_SYSTEM_STDIO);      
  
if (argc>1) sprintf(cmd,"%s",argv[1]);
else        sprintf(cmd,"%s",defaultcmd);
if (argc>2) {
 sprintf(fname,"%s", argv[2]);
 fp = fopen(fname,"a");
}
/* Begin by initializing the system*/
status = viOpenDefaultRM(&defaultRM);
if (status < VI_SUCCESS) {
/* Error Initializing VISA...exiting*/
  return -1;
}
/* Open communication with GPIB Device at Primary Addr 1*/
/* NOTE: For simplicity, we will not show error checking*/
status = viOpen(defaultRM, "GPIB0::21::INSTR", VI_NULL, VI_NULL,&instr);
if (status!=VI_SUCCESS){
return -2;
} 
/* Set the timeout for message-based communication*/
status = viSetAttribute(instr, VI_ATTR_TMO_VALUE, 5000);
if (status!=VI_SUCCESS){
return -3;
}
/* Ask the device for identification */
for (i=0;i<5;i++){
printf("%s\n",icmd[i]);
status = viWrite(instr, icmd[i], strlen(icmd[i]), &retCount);
}

/*
for (i=0;i<5;i++){
  printf("%s\n",icmd[i+5]); 
  WriteRead(instr, icmd[i+5],MAX_CNT,buffer);
}
*/

for (i=0;i<1;i++){  
WriteRead(instr, cmd,MAX_CNT,buffer);
}
/* Your code should process the data */
/* Close down the system */
status = viClose(instr);
if (status!=VI_SUCCESS){
return -4;
}
status = viClose(defaultRM);
if (status!=VI_SUCCESS){
return -5;
}
if (fp!=stdout) fclose(fp);
return 0;
}
