

#define USE_DAQ
#define USE_MIKRO
#define USE_HBOOK
// Izberi ustrezni interface v meniju projektnega okna
//  Options->CompilerDefines (dodaj /DSISVME ali /DWIENVME)


#ifdef USE_DAQ
#  define USE_CAMAC
#  ifdef SISVME
#    include "sisvme_dll.h"
#  endif
#  ifdef WIENVME
#    include "wienvme_dll.h"
#  endif

#include "CAENV462.h"
#include "CAENV830.h"
#include "CAENV814.h"
#endif

#include <userint.h>
#include <ansi_c.h>
#include <utility.h>
#include <vmescaler_ui.h>



#define V673A1_ADDR 0x121000
#define V673A2_ADDR 0x046000



#define SCA1_ADDR 0x200000
#define SCA2_ADDR 0x210000

#define V462_ADDR 0x100300
#define V814_ADDR 0x444400


#define MAX_THREADS 10

static int p1h, pID, rID, tfID;

static int ph_graph;
static int gceve=0;


static int daq_on;
static int poolHandle = 0;
static int dummy;

/*****************************************************************/
#ifdef USE_HBOOK
#define PAWC_SIZE 500000


static int hopen=0;

#define NTMAX 64
#define MAXEVE 100000

static int databuf[NTMAX][MAXEVE];

typedef struct { 
  int  evnt;
  float  time;
  int x,y;
  int  nh ;
  unsigned int  hits[NTMAX]; 
}  NTDEF;

static NTDEF NT;

#endif
/************************************************************/

 unsigned long buffer[64];

int getcounts(FILE *fp, float delay)
{
    
	int i,j;
    unsigned long data[100];
    int hdr[4];
    
	float stime;
	time_t timet;


	V830_map (0, SCA1_ADDR,1);
	V830_map (1, SCA2_ADDR,1);
	V462_map (0, V462_ADDR,1);
	
        V462_set0 (0, (int)(delay*1e7));
    
	
	V830_init (0);
	V830_init (1);
	
	 printf("delay %f\n", delay );
	Delay(0.01);
        for (j=0;j<NTMAX;j++) buffer[j]=0;
	V462_start0 (0);
	Delay(delay+0.1); 
	  
        V830_read(0,buffer) ;
	V830_read(1,&buffer[32]) ;
	  
	hdr[0]= 1; // RECID
	hdr[1]= (NTMAX+4)*sizeof(int);
	hdr[2]= time(&timet); 
	hdr[3]= (int) (delay*1e7);
	
	for (j=0;j<NTMAX;j++){
	  NT.hits[j]=buffer[j] ;
	}

	NT.nh=NTMAX; 
	
	if (fp!=stdout){
	  fwrite(&hdr,4,sizeof(int),fp);
	  fwrite(&NT.hits[0],NTMAX,sizeof(unsigned int),fp);
	  
	} else {
	  
	     for (j=0;j<NTMAX;j++){
	       fprintf(fp, "%lu\t", NT.hits[j]) ;
	     }
	     fprintf(fp,"\n");
	}
	
	V830_clear(0); 
	V830_clear(1); 
	return 0;
}


int CVICALLBACK daq_run(void *functionData)
{
    
	int i,j,ndat,dtype,ch,rg,adc,cres;
	int sum=0;
	long neve, ceve;
	float delay;
	unsigned long a,b,ec1,ec2;
    unsigned long data[100];

double min,max;
	int ntsave,status,fmax,ntev;
    char ntfile0[MAX_PATHNAME_LEN];
	float stime;
 	FILE *podrobnadatoteka;
int threshold=1, dthreshold=0, maxthreshold=0;
int width=10;
int mask=0xFFFF;	
	

    
	GetCtrlVal (p1h, P1_NT, &ntsave);
    if (ntsave) {
	  GetCtrlVal (p1h, P1_NTFILE, ntfile0);
	  ntev=0;
	  GetCtrlVal (p1h, P1_NEWF, &fmax);

    }
    

       GetCtrlVal (p1h, P1_THRESHOLD, &threshold);
       GetCtrlVal (p1h, P1_MAXTHRESHOLD, &maxthreshold);  
       GetCtrlVal (p1h, P1_DTHRESHOLD, &dthreshold);
       GetCtrlVal (p1h, P1_MASK, &mask);
       GetCtrlVal (p1h, P1_WIDTH, &width);

	GetCtrlVal (p1h, P1_NEVE, &neve);
	GetCtrlVal (p1h, P1_DELAY, &delay);
	

	V830_map (0, SCA1_ADDR,1);
	V830_map (1, SCA2_ADDR,1);
	V814_map (0, V814_ADDR,1);
	V462_map (0, V462_ADDR,1);
	
	
    V462_set0 (0, (int)(delay*1e7));
    

    
	
	V830_init (0);
	V830_init (1);
	

	Delay(0.01);
   for (j=0;j<NTMAX;j++) buffer[j]=0;
   stime= Timer();
   gceve=0;
   for (i=0;i<neve;i++){
	  
	  //hbookopen(ntev,fmax,ntfile0); 
          V814_init (0, threshold, width, mask);
           SetCtrlVal (p1h, P1_CTHRESHOLD, threshold);
          threshold+=dthreshold;
          
	  V462_start0 (0);
	  Delay(delay+0.1); 
	  
      V830_read(0,buffer) ;
	  V830_read(1,&buffer[32]) ;
	  NT.time=Timer()-stime; 
	  
	  sum=0;
	  for (j=0;j<NTMAX;j++){
	     databuf[j][i%MAXEVE]=buffer[j];
	     if (buffer[j]!=0) printf("%d %d\n",j,buffer[j]);
	     NT.hits[j]=buffer[j] ;
	     sum+=  buffer[j]; 
	  }
	  gceve=i%MAXEVE;
	  NT.evnt=i;
      
	  NT.nh=NTMAX; 
	  
	  //Hfnt(1000);    
	  ntev++;
	  printf("[%f]----------------------\n",NT.time);
	  V830_clear(0); 
	  V830_clear(1); 
	  
	  if (threshold>maxthreshold) break;
	  
	  if (!daq_on) break;
	}
	
	//
    //hbookend();
	return 0;
}


int update_plots (void)
{
  int daq_on, ch, status=0;
/*  
  SetCtrlVal(p1h, P1_CEVE, i);
	  
	  GetCtrlVal(p1h, P1_PLCH, &ch);
	  
	  
	  GetAxisScalingMode (p1h, P1_STRIPCHART, VAL_LEFT_YAXIS, VAL_MANUAL,&min, &max);
	  if (buffer[ch]> 0.9*max) {
	      do {
	      max*=2;
	      } while (max < buffer[ch]);
	      
	      SetAxisScalingMode (p1h, P1_STRIPCHART, VAL_LEFT_YAXIS, VAL_MANUAL,0.0, max);
	  }
	  PlotStripChartPoint (p1h, P1_STRIPCHART,buffer[ch]); 
	  
*/	  
  GetCtrlVal (p1h, P1_PLCH, &ch);
  
  GetCtrlVal (p1h, P1_DAQ, &daq_on);
  
  DeleteGraphPlot (p1h, P1_GRAPH, -1, VAL_DELAYED_DRAW);
  if (gceve>0) ph_graph = PlotY (p1h, P1_GRAPH, &databuf[ch][0], gceve,
								VAL_INTEGER, VAL_THIN_LINE,
								VAL_SIMPLE_DOT, VAL_SOLID, 1, VAL_RED);
  
  return (0);
}


int main (int argc, char **argv)
{
  int i,j;
  float delay=2;				
  char fname[100];
  int cmdline=0;
  FILE *fp=stdout;
  
  if (argc>1) cmdline=atoi(argv[1]);
  
  if (InitCVIRTE (0, argv, 0) == 0)
	return -1;	/* out of memory */
  if (cmdline==1){
     SetStdioPort (HOST_SYSTEM_STDIO);                      
  }  
  
  
  // initialize VME interface	
  VME_START(NULL);    
 
  printf("%s Started\n",argv[0]);

if (cmdline!=1){
  SetSleepPolicy(VAL_SLEEP_MORE);
  CmtNewThreadPool (MAX_THREADS, &poolHandle);

  SetStdioWindowOptions (1000, 0, 0);
  SetStdioWindowSize (100, 600);
  SetStdioWindowPosition (650, 15);

 // hbookinit();
  
  if ((p1h = LoadPanel (0, "vmescaler_ui.uir", P1)) < 0) return -1;
  DisplayPanel (p1h);

  do {
    GetUserEvent (1, &pID, &rID);
	switch (rID) {
	  case P1_DAQ:
		GetCtrlVal (p1h, P1_DAQ, &daq_on);
		if (daq_on) {
		  CmtScheduleThreadPoolFunction (poolHandle, daq_run, (void *)&dummy, &tfID);
		} else {
          CmtWaitForThreadPoolFunctionCompletion (poolHandle, tfID,
												  OPT_TP_PROCESS_EVENTS_WHILE_WAITING);
		  CmtReleaseThreadPoolFunctionID (poolHandle, tfID);
		} // */
	    break;

	  default:
	    printf("default: cnid= %d\n",rID);
	    update_plots();	
	    break;
	}
	
  } while ((rID != P1_EXIT)||daq_on);
	    
  CmtDiscardThreadPool (poolHandle);
  DiscardPanel (p1h);

} else {
  
  sprintf(fname,"");
  if (argc>3) {
    sprintf( fname,"%s",argv[3]);
    fp = fopen (fname, "ab");
  }
  if (argc>2) delay=atof(argv[2]);
  printf("arguments: fname %s delay %f\n", fname, delay);

  if (fp){
   getcounts(fp,delay);
   if (fp!=stdout) fclose(fp);
  }

}

#ifdef USE_VME
  // close VME interface
   VME_STOP(); 
#endif  
  return 0;
		
}


int CVICALLBACK cb_timer (int panel, int control, int event, void *callbackData,
                           int eventData1, int eventData2)
{
  QueueUserEvent (9000, p1h, P1_TIMER);
  return (0);
}

int CVICALLBACK Reset (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	switch (event)
		{
		case EVENT_COMMIT:
			  SetAxisScalingMode (p1h, P1_GRAPH, VAL_LEFT_YAXIS, VAL_MANUAL,0.0, 1); 
			break;
		}
	return 0;
}
